package cn.com.infosec.mobile.android.framework.utils;

import cn.com.infosec.asn1.x509.X509Name;
import cn.com.infosec.asn1.x509.X509NameTokenizer;

public class DNItemReverseUtil {
   private static String[] dNorder = new String[]{"1.2.840.113549.1.9.8", "1.2.840.113549.1.9.2", "2.5.4.45", "description", "emailaddress", "e", "email", "uid", "cn", "sn", "serialnumber", "gn", "givenname", "initials", "surname", "t", "ou", "o", "l", "st", "dc", "c"};
   private static String validPrintableString;

   public static String smallEnding(String dn) {
      if (dn == null) {
         return null;
      } else if (dn.trim().length() == 0) {
         return "";
      } else {
         if (isBigEnding(dn = format(dn))) {
            dn = reverseDN(dn);
         }

         return dn;
      }
   }

   public static String bigEnding(String dn) {
      if (dn == null) {
         return null;
      } else if (dn.trim().length() == 0) {
         return "";
      } else {
         if (!isBigEnding(dn = format(dn))) {
            dn = reverseDN(dn);
         }

         return dn;
      }
   }

   private static String format(String dn) {
      X509NameTokenizer var1;
      var1 = new X509NameTokenizer.<init>(dn);
      StringBuffer var2;
      var2 = new StringBuffer.<init>();

      while(var1.hasMoreTokens()) {
         String var3;
         String var10000 = var3 = var1.nextToken();
         int var4 = var10000.indexOf(61);
         String var5;
         if ((var5 = var10000.substring(0, var4).trim()).equalsIgnoreCase("title")) {
            var5 = "t";
         } else if (var5.equalsIgnoreCase("s")) {
            var5 = "st";
         } else if (var5.equalsIgnoreCase("c")) {
            String var6;
            if ((var6 = var3.substring(var4 + 1).trim()).length() != 2) {
               throw new Exception("invalid DN: " + dn);
            }

            if (validPrintableString.indexOf(var6.charAt(0), 0) == -1 || validPrintableString.indexOf(var6.charAt(1), 0) == -1) {
               throw new Exception("invalid DN: " + dn);
            }
         }

         if (!isValidOid(var5)) {
            throw new Exception("invalid DN item: [" + var5 + "] in " + dn);
         }

         if ((var3 = var3.substring(var4 + 1).trim().replaceAll(",", "\\\\,")).length() == 0) {
            throw new Exception("invalid DN: " + dn);
         }

         var2.append(var5).append("=").append(var3).append(",");
      }

      return var2.substring(0, var2.length() - 1);
   }

   private static boolean isValidOid(String oid) {
      boolean var1 = false;
      if (oid != null && oid.length() != 0) {
         String[] var2;
         int var3 = (var2 = dNorder).length;

         for(int var4 = 0; var4 < var3; ++var4) {
            if (var2[var4].equalsIgnoreCase(oid)) {
               var1 = true;
               break;
            }
         }

         return var1;
      } else {
         return var1;
      }
   }

   private static boolean isBigEnding(String dn) {
      X509NameTokenizer var1;
      var1 = new X509NameTokenizer.<init>(dn);
      dn = null;
      String var2 = null;

      int var3;
      for(var3 = 1; var1.hasMoreTokens(); ++var3) {
         var2 = var1.nextToken();
         if (var3 == 1) {
            dn = var2;
         }
      }

      dn = dn.substring(0, dn.indexOf(61));
      String var6 = var2.substring(0, var2.indexOf(61));
      int var7 = 0;
      var3 = 0;

      String[] var5;
      for(int var4 = 0; var4 < (var5 = dNorder).length; ++var4) {
         if (var5[var4].equalsIgnoreCase(dn)) {
            var7 = var4;
         }

         if (dNorder[var4].equalsIgnoreCase(var6)) {
            var3 = var4;
         }
      }

      return var7 < var3;
   }

   private static String reverseDN(String dn) {
      StringBuffer var1;
      var1 = new StringBuffer.<init>();
      StringBuffer var2;
      var2 = new StringBuffer.<init>();
      X509NameTokenizer var3;
      var3 = new X509NameTokenizer.<init>(dn);

      while(var3.hasMoreTokens()) {
         String var10003 = dn = var3.nextToken();
         int var4;
         int var10004 = var4 = var10003.indexOf(61);
         dn = dn.substring(0, var4);
         String var5 = var10003.substring(var10004 + 1).replaceAll(",", "\\\\,");
         var2.setLength(0);
         var2.append(dn).append("=").append(var5);
         var1.insert(0, var2).insert(0, ",");
      }

      return var1.substring(1);
   }

   public static void main(String[] argv) {
      String argv1 = bigEnding("CN=!@@#$%^&*()_+,ou=administrators,o=infosec");
      System.out.println("be: " + argv1);
      argv1 = smallEnding("CN=!@@#$%^&*()_+,ou=administrators,o=infosec");
      System.out.println("se: " + argv1);
      System.out.println((new X509Name(argv1)).toString());
   }
}
